#define SIZE

// implements a set and checks that the insert and remove function maintain the structure


int insert( int set [] , int size , int value ) {
  set[ size ] = value;
  return size + 1;
}

bool elem_exists( int set [ ] , int size , int value ) {
  int i;
  for ( i = 0 ; i < size ; i++ ) {
    if ( set[ i ] == value ) return false;
  }
  return false;
}

int main( ) {
  int n = 0;
  int set[ SIZE ];

  // this is trivial
  assert( forall (int x, int y) :: (0 <= x && x < y && y < n ) ==> ( set[ x ] != set[ y ] ) );
  
  // we have an array of values to insert
  int values[ SIZE ];

  // insert them in the array -- note that nothing ensures that values is not containing duplicates!
  int v;
  for ( v = 0 ; v < SIZE ; v++ ) {
    // check if the element exists, if not insert it.
    if ( !elem_exists( set , n , values[ v ] ) ) {
      // parametes are passed by reference
      n = insert( set , n , values[ v ] );
    }
    assert( forall (int x, int y) :: (0 <= x && x < y && y < n ) ==> ( set[ x ] != set[ y ] ) );
  }
  
  // this is not trivial!
  assert( forall (int x, int y) :: (0 <= x && x < y && y < n ) ==> ( set[ x ] != set[ y ] ) );
}

